function [ ] = cleDraw(cleDrawDat)
%cleDraw    - Draw cleDrawDat structure.
%
%   cleDraw(cleDrawDat)
%       cleDrawDat     - cleDrawDat data to be writen to CleWin.

global CleWin;

if (~isstruct(cleDrawDat))
    error('CleWin:CleDraw:InputError', ...
          'Incorrect input parameter.');
end;


layerIndex=CleWin.layer;
    
%------------------------------------------------------------
for n=1:length(cleDrawDat.cleCircle),
 cleInterfaceLayer(['#' num2str(cleDrawDat.cleCircle{n}.layer)]);
 cleInterfaceCircle(cleDrawDat.cleCircle{n}.x,...
                    cleDrawDat.cleCircle{n}.y,...
                    cleDrawDat.cleCircle{n}.radius);
end;
%------------------------------------------------------------

%------------------------------------------------------------
for n=1:length(cleDrawDat.cleBox),
 cleInterfaceLayer(['#' num2str(cleDrawDat.cleBox{n}.layer)]);
 if cleDrawDat.cleBox{n}.angle~=0
  cleInterfaceBox(cleDrawDat.cleBox{n}.x,...
                  cleDrawDat.cleBox{n}.y,...
                  cleDrawDat.cleBox{n}.length,...
                  cleDrawDat.cleBox{n}.width,...
                  (cleDrawDat.cleBox{n}.angle)/pi*180);
 else
  cleInterfaceRectangle(cleDrawDat.cleBox{n}.x-0.5*cleDrawDat.cleBox{n}.length,...
                        cleDrawDat.cleBox{n}.y-0.5*cleDrawDat.cleBox{n}.width,...
                        cleDrawDat.cleBox{n}.x+0.5*cleDrawDat.cleBox{n}.length,...
                        cleDrawDat.cleBox{n}.y+0.5*cleDrawDat.cleBox{n}.width);
 end;
end;
%------------------------------------------------------------

%------------------------------------------------------------
for n=1:length(cleDrawDat.clePolygon),
 cleInterfaceLayer(['#' num2str(cleDrawDat.clePolygon{n}.layer)]);
 cleInterfacePolygon(cleDrawDat.clePolygon{n}.points);
end;
%------------------------------------------------------------

%------------------------------------------------------------
for n=1:length(cleDrawDat.cleWire),
 style=0;
 if ( strcmp(cleDrawDat.cleWire{n}.style,'f') | strcmp(cleDrawDat.cleWire{n}.style,'flat'))
  style=1;
 elseif ( strcmp(cleDrawDat.cleWire{n}.style,'e') | strcmp(cleDrawDat.cleWire{n}.style,'extended'))
  style=2;
 end;
 cleInterfaceLayer(['#' num2str(cleDrawDat.cleWire{n}.layer)]);
 cleInterfaceWire(style,...
                  cleDrawDat.cleWire{n}.width,...
                  cleDrawDat.cleWire{n}.points);
end;
%------------------------------------------------------------

%------------------------------------------------------------
for n=1:length(cleDrawDat.cleRing),
 cleInterfaceLayer(['#' num2str(cleDrawDat.cleRing{n}.layer)]);
 cleInterfaceRing(cleDrawDat.cleRing{n}.x,...
                  cleDrawDat.cleRing{n}.y,...
                  cleDrawDat.cleRing{n}.radius,...
                  cleDrawDat.cleRing{n}.width);
end;
%------------------------------------------------------------

%------------------------------------------------------------
for n=1:length(cleDrawDat.cleText),
 cleInterfaceLayer(['#' num2str(cleDrawDat.cleText{n}.layer)]);
 theta=cleDrawDat.cleText{n}.angle;
 x=cleDrawDat.cleText{n}.x;
 y=cleDrawDat.cleText{n}.y;
 s=cleDrawDat.cleText{n}.scale;
 mx=1; my=1;
 if (cleDrawDat.cleText{n}.mirror(1)==true)
  mx=-1;
 end;
 if (cleDrawDat.cleText{n}.mirror(2)==true)
  my=-1;
 end; 
 T = [[mx*s*cos(theta) -my*s*sin(theta)  x ]; ...
      [mx*s*sin(theta)  my*s*cos(theta)  y ]; ...
      [0                       0                       1 ]];
 cleInterfaceText(cleDrawDat.cleText{n}.textString,T);
end;
%------------------------------------------------------------

%------------------------------------------------------------
for n=1:length(cleDrawDat.cleSymbol),
 theta=cleDrawDat.cleSymbol{n}.angle;
 x=cleDrawDat.cleSymbol{n}.x;
 y=cleDrawDat.cleSymbol{n}.y;
 s=cleDrawDat.cleSymbol{n}.scale;
 mx=1; my=1;
 if (cleDrawDat.cleSymbol{n}.mirror(1)==true)
  mx=-1;
 end;
 if (cleDrawDat.cleSymbol{n}.mirror(2)==true)
  my=-1;
 end; 
 T = [[mx*s*cos(theta) -my*s*sin(theta)  x ]; ...
      [mx*s*sin(theta)  my*s*cos(theta)  y ]; ...
      [0                       0                       1 ]];
 cleInterfaceSymbol(cleDrawDat.cleSymbol{n}.symbolName,T);
end;
%------------------------------------------------------------

cleInterfaceLayer(['#' num2str(layerIndex)]);
CleWin.layer=layerIndex;