function [ cleDrawDatOut ] = cleTranslate(cleDrawDatIn,deltaXY)
%cleTranslate    - Translate cleDrawDat structure.
%
%   cleDrawDat = cleTranslate(cleDrawDat, deltaXY)
%       deltaXY     - Nx2 array of [deltaX, deltaY] translation coordinates.

if (isstruct(cleDrawDatIn) & isnumeric(deltaXY) )
 if ( size(deltaXY,2)~=2 )
  deltaXY=deltaXY';
 end;

 if (size(deltaXY,2)~=2)
  error('CleWin:cleTranslate:InputError', ...
        'Incorrect input parameter(s).');
 end;
else
 error('CleWin:cleTranslate:InputError', ...
       'Incorrect input parameter(s).');
end;


cleDrawDatOut=cleEmpty();

for t=1:size(deltaXY,1),
 x=deltaXY(t,1);
 y=deltaXY(t,2);

 %------------------------------------------------------------
 for k=1:length(cleDrawDatIn.cleCircle),
  cleDrawDatOut.cleCircle{end+1}=cleDrawDatIn.cleCircle{k};
  cleDrawDatOut.cleCircle{end}.x=x+cleDrawDatIn.cleCircle{k}.x;
  cleDrawDatOut.cleCircle{end}.y=y+cleDrawDatIn.cleCircle{k}.y;
 end;
 %------------------------------------------------------------

 %------------------------------------------------------------
 for k=1:length(cleDrawDatIn.cleBox),
  cleDrawDatOut.cleBox{end+1}=cleDrawDatIn.cleBox{k};
  cleDrawDatOut.cleBox{end}.x=x+cleDrawDatIn.cleBox{k}.x;
  cleDrawDatOut.cleBox{end}.y=y+cleDrawDatIn.cleBox{k}.y;
 end;
 %------------------------------------------------------------

 %------------------------------------------------------------
 for k=1:length(cleDrawDatIn.clePolygon),
  nclePolygons=length(cleDrawDatOut.clePolygon)+1;
  cleDrawDatOut.clePolygon{nclePolygons}=cleDrawDatIn.clePolygon{k}; 

  for m=1:length(cleDrawDatIn.clePolygon{k}.points),
   cleDrawDatOut.clePolygon{nclePolygons}.points(:,1) = cleDrawDatIn.clePolygon{k}.points(:,1)+x;
   cleDrawDatOut.clePolygon{nclePolygons}.points(:,2) = cleDrawDatIn.clePolygon{k}.points(:,2)+y;
  end;
 end;
 %------------------------------------------------------------

 %------------------------------------------------------------
 for k=1:length(cleDrawDatIn.cleWire),
  ncleWires=length(cleDrawDatOut.cleWire)+1;
  cleDrawDatOut.cleWire{ncleWires}=cleDrawDatIn.cleWire{k};
  
  for m=1:length(cleDrawDatIn.cleWire{k}.points),
   cleDrawDatOut.cleWire{ncleWires}.points(:,1) = cleDrawDatIn.cleWire{k}.points(:,1)+x;
   cleDrawDatOut.cleWire{ncleWires}.points(:,2) = cleDrawDatIn.cleWire{k}.points(:,2)+y;
  end;
 end;
 %------------------------------------------------------------

 %------------------------------------------------------------
 for k=1:length(cleDrawDatIn.cleRing),
  cleDrawDatOut.cleRing{end+1}=cleDrawDatIn.cleRing{k};
  cleDrawDatOut.cleRing{end}.x=x+cleDrawDatIn.cleRing{k}.x;
  cleDrawDatOut.cleRing{end}.y=y+cleDrawDatIn.cleRing{k}.y;
 end;
 %------------------------------------------------------------

 %------------------------------------------------------------
 for k=1:length(cleDrawDatIn.cleText),
  cleDrawDatOut.cleText{end+1}=cleDrawDatIn.cleText{k};
  cleDrawDatOut.cleText{end}.x=x+cleDrawDatIn.cleText{k}.x;
  cleDrawDatOut.cleText{end}.y=y+cleDrawDatIn.cleText{k}.y;
 end;
 %------------------------------------------------------------

 %------------------------------------------------------------
 for k=1:length(cleDrawDatIn.cleSymbol),
  cleDrawDatOut.cleSymbol{end+1}=cleDrawDatIn.cleSymbol{k};
  cleDrawDatOut.cleSymbol{end}.x=x+cleDrawDatIn.cleSymbol{k}.x;
  cleDrawDatOut.cleSymbol{end}.y=y+cleDrawDatIn.cleSymbol{k}.y;
 end;
 %------------------------------------------------------------


end;

%------------------------------------------------------------
if nargout < 1,
 cleDraw(cleDrawDatOut)
end;

